
Ruby - Bug #4024

IO#readlines(0) never return

11/04/2010 11:08 PM - nagachika (Tomoyuki Chikanaga)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 1.9.3dev (2010-11-04 trunk 29690)

[x86_64-darwin10.4.0]

Backport:  

Description

=begin

1.9.2 および trunk で IO#readlines の引数に 0 を渡すと無限ループ状態になり処理がかえってこなくなります。

IO#each_line も同様に "" を yield し続けます。

(via http://twitter.com/#!/watson1978/status/29656929210)

readlines/each_line で limit に 0 が渡された時は例外にするのが良いのではないでしょうか。

パッチを添付します。

=end

Related issues:

Related to Ruby - Bug #18767: IO.foreach hangs up when passes limit=0 Closed

Associated revisions

Revision ee388f6ee2790908dffbb4b20d7d1d43b8ddb38a - 11/04/2010 03:39 PM - nobu (Nobuyoshi Nakada)

io.c (rb_io_readlines, rb_io_each_line): limit must not be zero.

a patch from Tomoyuki Chikanaga at [ruby-dev:42538].  #4024

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@29694 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 11/05/2010 12:47 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

=begin

This issue was solved with changeset r29694.

Tomoyuki, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

=end

#2 - 06/18/2022 02:56 AM - mame (Yusuke Endoh)

- Related to Bug #18767: IO.foreach hangs up when passes limit=0 added

Files

io_readlines.patch 1.35 KB 11/04/2010 nagachika (Tomoyuki Chikanaga)
